Index: /trunk/LMDZ.COMMON/libf/evolution/compute_tendencies_mod_slope.F90
===================================================================
--- /trunk/LMDZ.COMMON/libf/evolution/compute_tendencies_mod_slope.F90	(revision 2834)
+++ /trunk/LMDZ.COMMON/libf/evolution/compute_tendencies_mod_slope.F90	(revision 2835)
@@ -6,5 +6,4 @@
 
       IMPLICIT NONE
-
 
 !=======================================================================
@@ -34,7 +33,5 @@
 !=======================================================================
 
-
 !  We compute the difference
-!  tendencies_h2o_ice(:,:,:)=min_h2o_ice_Y2(:,:,:)-min_h2o_ice_Y1(:,:,:)
 
   DO j=1,jjm_input+1
@@ -46,42 +43,19 @@
   ENDDO
 
-     print *, "jjm_input+1", jjm_input+1
-     print *, "iim_input+1", iim_input+1
-     print *, "nslope+1", nslope+1
-
 !  If the difference is too small; there is no evolution
   DO j=1,jjm_input+1
     DO i = 1, iim_input
        DO islope = 1, nslope
-!         print *, "tendencies_h2o_ice(i,j,islope)LAAA", tendencies_h2o_ice(i,j,islope)
          if(abs(tendencies_h2o_ice(i,j,islope)).LT.1.0E-10) then
             tendencies_h2o_ice(i,j,islope)=0.
          endif
-!         print *, "tendencies_h2o_ice(i,j,islope)HERE", tendencies_h2o_ice(i,j,islope)
        enddo
     ENDDO
   ENDDO
 
-
-!  We reorganise the difference on the physical grid
-  tendencies_h2o_ice_phys(1,:)=tendencies_h2o_ice(1,1,:)
-
-  ig0 = 2
-  DO j=2,jjm_input
-    DO i = 1, iim_input
-       tendencies_h2o_ice_phys(ig0,:)  =tendencies_h2o_ice(i,j,:)
-       ig0= ig0 + 1
-    ENDDO
+  DO islope = 1,nslope
+    CALL gr_dyn_fi(1,iim_input+1,jjm_input+1,ngrid,tendencies_h2o_ice(:,:,islope),tendencies_h2o_ice_phys(:,islope))
   ENDDO
-
-  tendencies_h2o_ice_phys(ig0,:) = tendencies_h2o_ice(1,jjm_input+1,:)
-
-!  print *, "tendencies_h2o_ice_physze", tendencies_h2o_ice_phys(:,:)
-
 
 END SUBROUTINE compute_tendencies_slope
 
-
-
-
-
Index: /trunk/LMDZ.COMMON/libf/evolution/criterion_co2_ice_stop_mod.F90
===================================================================
--- /trunk/LMDZ.COMMON/libf/evolution/criterion_co2_ice_stop_mod.F90	(revision 2834)
+++ /trunk/LMDZ.COMMON/libf/evolution/criterion_co2_ice_stop_mod.F90	(revision 2835)
@@ -23,6 +23,4 @@
   REAL,    intent(in) ::  latitude(ngrid)          ! physical point field : Latitude
   REAL,    intent(in) ::  initial_co2_ice(n_band_lat)  ! Initial/Actual surface of water ice
-
-
 
 !   OUTPUT
@@ -59,7 +57,4 @@
        present_co2(j).GT.initial_co2_ice(j)*(1+alpha_criterion)) then
          STOPPING=.TRUE. 
-         print *, "j", j
-         print *, "present_co2(j)", present_co2(j)
-         print *, "initial_co2_ice(j)", initial_co2_ice(j)
     endif
   enddo
Index: /trunk/LMDZ.COMMON/libf/evolution/criterion_ice_stop_mod_slope.F90
===================================================================
--- /trunk/LMDZ.COMMON/libf/evolution/criterion_ice_stop_mod_slope.F90	(revision 2834)
+++ /trunk/LMDZ.COMMON/libf/evolution/criterion_ice_stop_mod_slope.F90	(revision 2835)
@@ -20,5 +20,5 @@
 !   INPUT
   INTEGER, intent(in) :: ngrid,nslope                  ! # of grid physical grid points 
-  REAL,    intent(in) :: cell_area(ngrid)       ! physical point field : Area of the cells
+  REAL,    intent(in) :: cell_area(ngrid)              ! physical point field : Area of the cells
   REAL,    intent(in) ::  qsurf(ngrid,nslope)          ! physical point field : Actual density of water ice
   REAL,    intent(in) :: ini_surf
@@ -27,5 +27,4 @@
   REAL,    intent(in) :: global_ave_press_new
 
-
 !   OUTPUT
   LOGICAL, intent(out) :: STOPPING              ! Logical : is the criterion reached?
@@ -33,5 +32,5 @@
 !   local:
 !   -----
-  INTEGER :: i,islope                    ! Loop
+  INTEGER :: i,islope   ! Loop
   REAL :: present_surf  ! Initial/Actual surface of water ice
 
@@ -46,25 +45,18 @@
    do islope=1,nslope
       if (initial_h2o_ice(i,islope).GT.0.5 .and. qsurf(i,islope).GT.0.) then
-         print *, "i", i
-         print *, "initial_h2o_ice(i,islope)", initial_h2o_ice(i,islope)
-         print *, "qsurf(i,:)", qsurf(i,:)
-         print *, "cell_area(i)", cell_area(i)
-         print *, "present_surf",present_surf
          present_surf=present_surf+cell_area(i)*subslope_dist(i,islope)
       endif
    enddo
   enddo
-
-!  print *, "initial_h2o_ice", initial_h2o_ice
-!  print *, "qsurf", qsurf
-
-  print *, "present_surf", present_surf
-  print *, "ini_surf", ini_surf
-  print *, "ini_surf*0.8", ini_surf*(1-alpha_criterion)
   
 !   check of the criterion
   if(present_surf.LT.ini_surf*(1-alpha_criterion) .OR. &
      present_surf.GT.ini_surf*(1+alpha_criterion)) then
-  STOPPING=.TRUE. 
+    STOPPING=.TRUE. 
+    print *, "Reason of stopping : The surface of co2 ice sublimating reach the threshold:"
+    print *, "Current surface of co2 ice sublimating=", present_surf
+    print *, "Initial surface of co2 ice sublimating=", ini_surf
+    print *, "Percentage of change accepted=", alpha_criterion*100
+    print *, "present_surf<ini_surf*(1-alpha_criterion)", (present_surf.LT.ini_surf*(1-alpha_criterion))
   endif
 
@@ -73,12 +65,12 @@
   endif
 
-!  if(global_ave_press_GCM.LT.global_ave_press_new*(1-alpha_criterion) .OR. &
-!     global_ave_press_GCM.GT.global_ave_press_new*(1+alpha_criterion)) then
-!  STOPPING=.TRUE. 
-!  endif
-
   if(global_ave_press_new.LT.global_ave_press_GCM*(0.9) .OR. &
      global_ave_press_new.GT.global_ave_press_GCM*(1.1)) then
-  STOPPING=.TRUE. 
+    STOPPING=.TRUE. 
+    print *, "Reason of stopping : The global pressure reach the threshold:"
+    print *, "Current global pressure=", global_ave_press_new
+    print *, "GCM global pressure=", global_ave_press_GCM
+    print *, "Percentage of change accepted=", 0.1*100
+    print *, "global_ave_press_new<global_ave_press_GCM*(0.9)", (global_ave_press_new.LT.global_ave_press_GCM*(0.9))
   endif
 
@@ -86,5 +78,2 @@
 
 
-
-
-
Index: /trunk/LMDZ.COMMON/libf/evolution/criterion_ice_stop_mod_water_slope.F90
===================================================================
--- /trunk/LMDZ.COMMON/libf/evolution/criterion_ice_stop_mod_water_slope.F90	(revision 2834)
+++ /trunk/LMDZ.COMMON/libf/evolution/criterion_ice_stop_mod_water_slope.F90	(revision 2835)
@@ -25,5 +25,4 @@
   REAL,    intent(in) :: initial_h2o_ice(ngrid,nslope)
 
-
 !   OUTPUT
   LOGICAL, intent(out) :: STOPPING              ! Logical : is the criterion reached?
@@ -39,34 +38,27 @@
     STOPPING=.FALSE.
 
-!   computation of the actual surface
+!   computation of the present surface of water ice sublimating
   present_surf=0.
   do i=1,ngrid
     do islope=1, nslope
       if (initial_h2o_ice(i,islope).GT.0.5 .and. qsurf(i,islope).GT.0.) then
-!         print *, "i", i
-!         print *, "initial_h2o_ice(i,islope)", initial_h2o_ice(i,islope)
-!         print *, "qsurf(i,islope)", qsurf(i,islope)
-!         print *, "cell_area(i)", cell_area(i)
-!         print *, "present_surf",present_surf
          present_surf=present_surf+cell_area(i)*subslope_dist(i,islope)
       endif
     enddo
   enddo
-
-!  print *, "initial_h2o_ice", initial_h2o_ice
-!  print *, "qsurf", qsurf
-
-!  print *, "present_surf", present_surf
-!  print *, "ini_surf", ini_surf
-!  print *, "ini_surf*0.8", ini_surf*(1-alpha_criterion)
   
 !   check of the criterion
   if(present_surf.LT.ini_surf*(1-alpha_criterion) .OR. &
      present_surf.GT.ini_surf*(1+alpha_criterion)) then
-  STOPPING=.TRUE. 
+    STOPPING=.TRUE. 
+    print *, "Reason of stopping : The surface of water ice sublimating reach the threshold:"
+    print *, "Current surface of water ice sublimating=", present_surf
+    print *, "Initial surface of water ice sublimating=", ini_surf
+    print *, "Percentage of change accepted=", alpha_criterion*100
+    print *, "present_surf<ini_surf*(1-alpha_criterion)", (present_surf.LT.ini_surf*(1-alpha_criterion))
   endif
 
   if (ini_surf.LT. 1E-5 .and. ini_surf.GT. -1E-5) then
-       STOPPING=.FALSE.
+    STOPPING=.FALSE.
   endif
 
Index: /trunk/LMDZ.COMMON/libf/evolution/evol_co2_ice_s_mod_slope.F90
===================================================================
--- /trunk/LMDZ.COMMON/libf/evolution/evol_co2_ice_s_mod_slope.F90	(revision 2834)
+++ /trunk/LMDZ.COMMON/libf/evolution/evol_co2_ice_s_mod_slope.F90	(revision 2835)
@@ -21,5 +21,4 @@
 
   INTEGER, intent(in) :: iim_input,jjm_input, ngrid,nslope   ! # of grid points along longitude/latitude/ total
-!  REAL, intent(in) ::  tendencies_h2o_ice_phys(ngrid) ! physical point field : Evolution of perenial ice over one year
   REAL, intent(in) ::  cell_area(ngrid)
 
@@ -28,5 +27,4 @@
   LOGICAL :: STOPPING
   REAL, intent(inout) ::  tendencies_co2_ice_phys(ngrid,nslope) ! physical point field : Evolution of perenial ice over one year
-
 
 !   local:
Index: /trunk/LMDZ.COMMON/libf/evolution/evol_h2o_ice_s_mod_slope.F90
===================================================================
--- /trunk/LMDZ.COMMON/libf/evolution/evol_h2o_ice_s_mod_slope.F90	(revision 2834)
+++ /trunk/LMDZ.COMMON/libf/evolution/evol_h2o_ice_s_mod_slope.F90	(revision 2835)
@@ -6,5 +6,5 @@
 
   USE temps_mod_evol, ONLY: dt_pem
-  	  use comslope_mod, ONLY: subslope_dist
+  use comslope_mod, ONLY: subslope_dist
 
       IMPLICIT NONE
@@ -22,5 +22,4 @@
 
   INTEGER, intent(in) :: iim_input,jjm_input, ngrid,nslope   ! # of grid points along longitude/latitude/ total
-!  REAL, intent(in) ::  tendencies_h2o_ice_phys(ngrid) ! physical point field : Evolution of perenial ice over one year
   REAL, intent(in) ::  cell_area(ngrid)
 
@@ -30,17 +29,12 @@
   REAL, intent(inout) ::  tendencies_h2o_ice_phys(ngrid,nslope) ! physical point field : Evolution of perenial ice over one year
 
-
 !   local:
 !   ----
 
   INTEGER :: i,j,ig0,islope                                  ! loop variable
-!  REAL :: not_budget, budget
   REAL :: pos_tend, neg_tend, real_coefficient,negative_part
   REAL ::  new_tendencies(ngrid,nslope)
 
-
 !=======================================================================
-
-!  budget=sum(qsurf(:))
 
   pos_tend=0.
@@ -59,12 +53,8 @@
   enddo
 
-!  print *, "pos_tend", pos_tend
-!  print *, "neg_tend", neg_tend
-
   if(neg_tend.GT.pos_tend .and. pos_tend.GT.0) then
      do i=1,ngrid
        do islope=1,nslope
        if(tendencies_h2o_ice_phys(i,islope).LT.0) then
-!          print *, "pos_tend/neg_tend", pos_tend/neg_tend
           new_tendencies(i,islope)=tendencies_h2o_ice_phys(i,islope)*(pos_tend/neg_tend)
        else
@@ -74,5 +64,4 @@
      enddo
   elseif(neg_tend.LT.pos_tend .and. neg_tend.GT.0) then
-!          print *, "neg_tend/pos_tend", neg_tend/pos_tend
      do i=1,ngrid
        do islope=1,nslope
@@ -85,6 +74,8 @@
      enddo
   elseif(pos_tend.EQ.0 .OR. neg_tend.EQ.0) then 
-
-!      call criterion_ice_stop(cell_area,1,qsurf*0.,STOPPING,ngrid,cell_area)
+    print *, "Reason of stopping : There is either no water ice sublimating or no water ice increasing !!"
+    print *, "Tendencies on ice sublimating=", neg_tend
+    print *, "Tendencies on ice increasing=", pos_tend
+    print *, "This can be due to the absence of water ice in the PCM run!!"
       call criterion_ice_stop_water_slope(cell_area,1,qsurf(:,:)*0.,STOPPING,ngrid,cell_area)
       do i=1,ngrid
@@ -95,38 +86,19 @@
   endif
 
- 
-  
   negative_part = 0.
-
 
 ! Evolution of the water ice for each physical point
   do i=1,ngrid
     do islope=1, nslope
-!      qsurf(i)=qsurf(i)+tendencies_h2o_ice_phys(i)*dt_pem
       qsurf(i,islope)=qsurf(i,islope)+new_tendencies(i,islope)*dt_pem
-!      budget=budget+tendencies_h2o_ice_phys(i)*dt_pem
       if (qsurf(i,islope).lt.0) then
-!        not_budget=not_budget+qsurf(i)
-!       print *, "NNqsurf(i,islope)", qsurf(i,islope)
-!       print *, "NNnew_tendencies(i,islope)", new_tendencies(i,islope)
-!       print *, "NNtendencies_h2o_ice_phys(i,islope)", tendencies_h2o_ice_phys(i,islope)
         negative_part=negative_part-qsurf(i,islope)*cell_area(i)*subslope_dist(i,islope)
         qsurf(i,islope)=0.
         tendencies_h2o_ice_phys(i,islope)=0.
-!        print *, "NNineg", i
-      endif
-      if(qsurf(i,islope).NE.qsurf(i,islope)) then
-!          print *, "qsurf(i,islope)",qsurf(i,islope)
-!          print *, "new_tendencies",new_tendencies(i,islope)
-!          print *, "tendencies_h2o_ice_phys",tendencies_h2o_ice_phys(i,islope)
-!          print *, "i", i
-!          print *,"islope",islope
       endif
     enddo
   enddo
 
-!  print *, "negative_part", negative_part
   real_coefficient=negative_part/pos_tend
-!  print *, "real_coefficient", real_coefficient
 
   do i=1,ngrid
@@ -140,7 +112,3 @@
 
 
-! Conservation of water ice
-!  qsurf(:)=qsurf(:)*budget/sum(qsurf(:))
-
-
 END SUBROUTINE evol_h2o_ice_s_slope
Index: /trunk/LMDZ.COMMON/libf/evolution/ini_soil_mod.F90
===================================================================
--- /trunk/LMDZ.COMMON/libf/evolution/ini_soil_mod.F90	(revision 2834)
+++ /trunk/LMDZ.COMMON/libf/evolution/ini_soil_mod.F90	(revision 2835)
@@ -1,4 +1,3 @@
       MODULE ini_soil_mod
-
 
       IMPLICIT NONE
@@ -6,9 +5,6 @@
       CONTAINS    
 
-
      subroutine ini_icetable(timelen,ngrid,nsoil_PEM, &
                therm_i, timestep,tsurf_ave,tsoil_ave,tsurf_inst, tsoil_inst,q_co2,q_h2o,ps,ice_table)
-
-
 
       use vertical_layers_mod, only: ap,bp
@@ -28,8 +24,4 @@
 
 #include "dimensions.h"
-!#include "dimphys.h"
-
-!#include"comsoil.h"
-
 
 !-----------------------------------------------------------------------
@@ -41,5 +33,4 @@
       integer,intent(in) :: nsoil_PEM	! number of soil layers  in the PEM
 
-
       real,intent(in) :: timestep	    ! time step
       real,intent(in) :: tsurf_ave(ngrid)   ! surface temperature
@@ -49,5 +40,4 @@
       real,intent(in) :: ps(ngrid,timelen)                        ! surface pressure [Pa]
       real,intent(in) :: tsurf_inst(ngrid,timelen) ! soil (mid-layer) temperature
-
 
 ! outputs:
@@ -57,6 +47,4 @@
       real,intent(inout) :: therm_i(ngrid,nsoil_PEM) ! thermal inertia
 
-
-      
 ! local variables:
       integer ig,isoil,it,k,iref
@@ -99,46 +87,39 @@
     real,allocatable :: diff_rho(:)                    ! difference of vapor content
 
-
-      A =(1/m_co2 - 1/m_noco2)
-      B=1/m_noco2
-
-
- ice_table(:) = 1.
-do ig = 1,ngrid
- 
- error_depth = 1.
- countloop = 0
-
-
-    
- do while(( error_depth.gt.tol_error).and.(countloop.lt.countmax).and.(ice_table(ig).gt.-1e-20))
-    
-    countloop = countloop +1
-    Tcol_saved(:) = tsoil_ave(ig,:)
+    A =(1/m_co2 - 1/m_noco2)
+    B=1/m_noco2
+
+    ice_table(:) = 1.
+    do ig = 1,ngrid
+      error_depth = 1.
+      countloop = 0
+    
+      do while(( error_depth.gt.tol_error).and.(countloop.lt.countmax).and.(ice_table(ig).gt.-1e-20))
+    
+        countloop = countloop +1
+        Tcol_saved(:) = tsoil_ave(ig,:)
 
 !2.  Compute ice table
 
 ! 2.1 Compute  water density at the surface, yearly averaged
-    allocate(mass_mean(timelen))
+        allocate(mass_mean(timelen))
 !   1.1 Compute the partial pressure of vapor
 ! a. the molecular mass into the column
        mass_mean(:) = 1/(A*q_co2(ig,:) +B)
 ! b. pressure level
-     allocate(zplev(timelen))
-     do it = 1,timelen
+        allocate(zplev(timelen))
+        do it = 1,timelen
          zplev(it) = ap(1) + bp(1)*ps(ig,it)
-     enddo
+        enddo
 
 ! c. Vapor pressure
-     allocate(pvapor(timelen))
-     pvapor(:) = mass_mean(:)/m_h2o*q_h2o(ig,:)*zplev(:)
-     deallocate(zplev) 
-     deallocate(mass_mean)
-
-
+        allocate(pvapor(timelen))
+        pvapor(:) = mass_mean(:)/m_h2o*q_h2o(ig,:)*zplev(:)
+        deallocate(zplev) 
+        deallocate(mass_mean)
   
 !  d!  Check if there is frost at the surface and then compute the density
 !    at the surface
-     allocate(rhovapor(timelen))
+        allocate(rhovapor(timelen))
 
          do it = 1,timelen
@@ -146,132 +127,109 @@
            rhovapor(it) = min(psv_surf,pvapor(it))/tsurf_inst(ig,it)
          enddo
-     deallocate(pvapor)
-     rhovapor_avg =     SUM(rhovapor(:),1)/timelen                     
-     deallocate(rhovapor)
+        deallocate(pvapor)
+        rhovapor_avg =SUM(rhovapor(:),1)/timelen                     
+        deallocate(rhovapor)
 
 ! 2.2 Compute  water density at the soil layer, yearly averaged
 
-     allocate(rho_soil(timelen))
-     allocate(rho_soil_avg(nsoil_PEM))
-
-
-
-      do isoil = 1,nsoil_PEM
-        do it = 1,timelen 
-              rho_soil(it) = exp(alpha/tsoil_inst(ig,isoil,it) +beta)/tsoil_inst(ig,isoil,it)        
-       enddo
-       rho_soil_avg(isoil) = SUM(rho_soil(:),1)/timelen     
-      enddo
-     deallocate(rho_soil)
+        allocate(rho_soil(timelen))
+        allocate(rho_soil_avg(nsoil_PEM))
+
+        do isoil = 1,nsoil_PEM
+          do it = 1,timelen 
+            rho_soil(it) = exp(alpha/tsoil_inst(ig,isoil,it) +beta)/tsoil_inst(ig,isoil,it)        
+          enddo
+         rho_soil_avg(isoil) = SUM(rho_soil(:),1)/timelen     
+        enddo
+        deallocate(rho_soil)
          
-
 !2.3 Final: compute ice table
-         icedepth_prev = ice_table(ig)
-         ice_table(ig) = -1
-         allocate(diff_rho(nsoil_PEM))
-         do isoil = 1,nsoil_PEM
-             diff_rho(isoil) = rhovapor_avg -  rho_soil_avg(isoil)
+        icedepth_prev = ice_table(ig)
+        ice_table(ig) = -1
+        allocate(diff_rho(nsoil_PEM))
+        do isoil = 1,nsoil_PEM
+          diff_rho(isoil) = rhovapor_avg -  rho_soil_avg(isoil)
+        enddo
+        deallocate(rho_soil_avg)
+
+        if(diff_rho(1) > 0) then
+          ice_table(ig) = 0.
+        else
+          do isoil = 1,nsoil_PEM -1
+            if((diff_rho(isoil).lt.0).and.(diff_rho(isoil+1).gt.0.)) then
+              z1 = (diff_rho(isoil) - diff_rho(isoil+1))/(layer_PEM(isoil) - layer_PEM(isoil+1))
+              z2 = -layer_PEM(isoil+1)*z1 +  diff_rho(isoil+1)
+              ice_table(ig) = -z2/z1
+              exit
+            endif
+          enddo
+        endif
+    
+        deallocate(diff_rho)
+
+!3. Update Soil Thermal Inertia
+
+        if (ice_table(ig).gt. 0.) then
+          if (ice_table(ig).lt. 1e-10) then
+            do isoil = 1,nsoil_PEM
+              therm_i(ig,isoil)=ice_inertia
+            enddo
+          else 
+      ! 4.1 find the index of the mixed layer
+          iref=0 ! initialize iref
+          do k=1,nsoil_PEM ! loop on layers
+            if (ice_table(ig).ge.layer_PEM(k)) then
+              iref=k ! pure regolith layer up to here
+            else
+              ! correct iref was obtained in previous cycle
+            exit
+            endif
+          enddo
+
+      ! 4.2 Build the new ti
+         do isoil=1,iref
+           therm_i(ig,isoil) =inertiedat_PEM(ig,isoil) 
          enddo
-         deallocate(rho_soil_avg)
-
-
-         if(diff_rho(1) > 0) then
-           ice_table(ig) = 0.
-         else
-           do isoil = 1,nsoil_PEM -1
-             if((diff_rho(isoil).lt.0).and.(diff_rho(isoil+1).gt.0.)) then
-               z1 = (diff_rho(isoil) - diff_rho(isoil+1))/(layer_PEM(isoil) - layer_PEM(isoil+1))
-               z2 = -layer_PEM(isoil+1)*z1 +  diff_rho(isoil+1)
-               ice_table(ig) = -z2/z1
-               exit
-             endif
-           enddo
-          endif
-
-
-    
-    deallocate(diff_rho)
-
-
-!3. Update Soil Thermal Inertia
-
-  if (ice_table(ig).gt. 0.) then
-  if (ice_table(ig).lt. 1e-10) then
-      do isoil = 1,nsoil_PEM
-      therm_i(ig,isoil)=ice_inertia
-      enddo
-  else 
-      ! 4.1 find the index of the mixed layer
-      iref=0 ! initialize iref
-      do k=1,nsoil_PEM ! loop on layers
-        if (ice_table(ig).ge.layer_PEM(k)) then
-          iref=k ! pure regolith layer up to here
-        else
-         ! correct iref was obtained in previous cycle
-         exit
-        endif
-       
-      enddo
-
-
-
-      ! 4.2 Build the new ti
-      do isoil=1,iref
-         therm_i(ig,isoil) =inertiedat_PEM(ig,isoil) 
-      enddo
-
-
-      if (iref.lt.nsoil_PEM) then
-        if (iref.ne.0) then
-          ! mixed layer
-           therm_i(ig,iref+1)=sqrt((layer_PEM(iref+1)-layer_PEM(iref))/ &
-            (((ice_table(ig)-layer_PEM(iref))/(inertiedat_PEM(ig,iref)**2))+ &
+
+         if (iref.lt.nsoil_PEM) then
+           if (iref.ne.0) then
+             ! mixed layer
+             therm_i(ig,iref+1)=sqrt((layer_PEM(iref+1)-layer_PEM(iref))/ &
+              (((ice_table(ig)-layer_PEM(iref))/(inertiedat_PEM(ig,iref)**2))+ &
                       ((layer_PEM(iref+1)-ice_table(ig))/(ice_inertia**2))))
             
-
-
-        else ! first layer is already a mixed layer
-          ! (ie: take layer(iref=0)=0)
-          therm_i(ig,1)=sqrt((layer_PEM(1))/ &
+           else ! first layer is already a mixed layer
+            ! (ie: take layer(iref=0)=0)
+            therm_i(ig,1)=sqrt((layer_PEM(1))/ &
                           (((ice_table(ig))/(inertiedat_PEM(ig,1)**2))+ &
                            ((layer_PEM(1)-ice_table(ig))/(ice_inertia**2))))
-        endif ! of if (iref.ne.0)        
-        ! lower layers of pure ice
-        do isoil=iref+2,nsoil_PEM
-          therm_i(ig,isoil)=ice_inertia
-        enddo
-      endif ! of if (iref.lt.(nsoilmx))
-      endif ! permanent glaciers
-
-
+           endif ! of if (iref.ne.0)        
+           ! lower layers of pure ice
+           do isoil=iref+2,nsoil_PEM
+             therm_i(ig,isoil)=ice_inertia
+           enddo
+         endif ! of if (iref.lt.(nsoilmx))
+       endif ! permanent glaciers
 
        call soil_pem_1D(nsoil_PEM,.true.,therm_i(ig,:),timestep,tsurf_ave(ig),tsoil_ave(ig,:),alph_PEM,beta_PEM) 
-
        call soil_pem_1D(nsoil_PEM,.false.,therm_i(ig,:),timestep,tsurf_ave(ig),tsoil_ave(ig,:),alph_PEM,beta_PEM) 
 
-
-      do it = 1,timelen 
-        tsoil_inst(ig,:,it) = tsoil_inst(ig,:,it) - (Tcol_saved(:) - tsoil_ave(ig,:))
-      enddo
-
-
-
-      error_depth = abs(icedepth_prev - ice_table(ig))
-      
-     endif
-
-
-enddo
-
- error_depth = 1.
- countloop = 0
-enddo
+       do it = 1,timelen 
+         tsoil_inst(ig,:,it) = tsoil_inst(ig,:,it) - (Tcol_saved(:) - tsoil_ave(ig,:))
+       enddo
+
+       error_depth = abs(icedepth_prev - ice_table(ig))      
+       endif
+
+     enddo
+
+     error_depth = 1.
+     countloop = 0
+   enddo
  
-
       END SUBROUTINE ini_icetable
       subroutine soil_pem_1D(nsoil,firstcall, &
                therm_i,                          &
                timestep,tsurf,tsoil,alph,beta)
-
 
       use comsoil_h_PEM, only: layer_PEM, mlayer_PEM,  &
@@ -309,8 +267,4 @@
       real,intent(inout) :: alph(nsoil-1)
       real,intent(inout) :: beta(nsoil-1)
-
-
-
-
       
 ! local variables:
@@ -330,5 +284,4 @@
 	enddo
 
-
 ! 0.2 Build thermdiff(:), the "interlayer" thermal diffusivities
         do ik=1,nsoil-1
@@ -336,5 +289,4 @@
                      +(mlayer_PEM(ik)-layer_PEM(ik))*mthermdiff_PEM(ik-1))  &
                          /(mlayer_PEM(ik)-mlayer_PEM(ik-1))
-
 	enddo
 
@@ -365,11 +317,5 @@
 	enddo
 
-
-
-      
-  
 endif ! of if (firstcall)
-
-
 
       IF (.not.firstcall) THEN
@@ -387,7 +333,4 @@
       
           ENDIF
-
-
-
 
 !  2. Compute beta_PEM coefficients (preprocessing for next time step)
@@ -405,13 +348,5 @@
       enddo
 
-
-
       end
 
-
-
-
-      END MODULE ini_soil_mod
-
-
-      
+      END MODULE ini_soil_mod      
Index: /trunk/LMDZ.COMMON/libf/evolution/lask_param_mod.F90
===================================================================
--- /trunk/LMDZ.COMMON/libf/evolution/lask_param_mod.F90	(revision 2835)
+++ /trunk/LMDZ.COMMON/libf/evolution/lask_param_mod.F90	(revision 2835)
@@ -0,0 +1,37 @@
+module lask_param_mod
+
+implicit none
+
+  real,save,allocatable :: yearlask(:)
+  real,save,allocatable :: oblask(:)
+  real,save,allocatable :: exlask(:)
+  real,save,allocatable :: lsplask(:)
+  integer, save :: last_ilask
+
+contains
+
+  subroutine ini_lask_param_mod(nlask)
+  
+  implicit none
+  integer,intent(in) :: nlask ! number of line
+  
+  allocate(yearlask(nlask))
+  allocate(oblask(nlask))
+  allocate(exlask(nlask))
+  allocate(lsplask(nlask))
+  
+  end subroutine ini_lask_param_mod
+
+
+  subroutine end_lask_param_mod
+
+  implicit none
+
+  if (allocated(yearlask)) deallocate(yearlask)
+  if (allocated(oblask)) deallocate(oblask)
+  if (allocated(exlask)) deallocate(exlask)
+  if (allocated(lsplask)) deallocate(lsplask)
+
+  end subroutine end_lask_param_mod
+  
+end module lask_param_mod
Index: /trunk/LMDZ.COMMON/libf/evolution/nb_time_step_GCM.F90
===================================================================
--- /trunk/LMDZ.COMMON/libf/evolution/nb_time_step_GCM.F90	(revision 2834)
+++ /trunk/LMDZ.COMMON/libf/evolution/nb_time_step_GCM.F90	(revision 2835)
@@ -56,4 +56,6 @@
   CALL err(NF90_CLOSE(fID),"close",fichnom)
 
+  print *, "The number of timestep of the PCM run data=", timelen
+
   CONTAINS
 
Index: /trunk/LMDZ.COMMON/libf/evolution/orbit_param_criterion_mod.F90
===================================================================
--- /trunk/LMDZ.COMMON/libf/evolution/orbit_param_criterion_mod.F90	(revision 2835)
+++ /trunk/LMDZ.COMMON/libf/evolution/orbit_param_criterion_mod.F90	(revision 2835)
@@ -0,0 +1,167 @@
+      MODULE orbit_param_criterion_mod
+
+      IMPLICIT NONE
+
+      CONTAINS
+
+      SUBROUTINE orbit_param_criterion(year_iter_max)
+
+      USE temps_mod_evol, ONLY: year_bp_ini, year_PEM
+      USE planete_h, ONLY: e_elips, obliquit, timeperi
+      USE comcstfi_h, only: pi
+      USE lask_param_mod, only: yearlask,oblask,exlask,lsplask, &
+   				ini_lask_param_mod,last_ilask
+
+      IMPLICIT NONE
+
+!--------------------------------------------------------
+! Input Variables
+!--------------------------------------------------------
+
+!--------------------------------------------------------
+! Output Variables
+!--------------------------------------------------------
+
+      integer,intent(out) :: year_iter_max	! Maximum number of iteration of the PEM before orb changes too much
+
+!--------------------------------------------------------
+! Local variables 
+!--------------------------------------------------------
+
+      real :: Year	                ! Year of the simulation
+      real :: timeperi_ls	                ! Year of the simulation
+      integer nlask,ilask!,last_ilask !Loop variable
+      parameter (nlask = 20001)
+
+      real max_change_obl,max_change_ex,max_change_lsp ! Percentage of change that is considered to be acceptible
+
+      real max_obl,max_ex,max_lsp !Maximum value of orbit param given the acceptable percentage 
+      real min_obl,min_ex,min_lsp !Maximum value of orbit param given the acceptable percentage
+
+      real max_obl_iter,max_ex_iter,max_lsp_iter !Maximum year iteration before reaching an unacceptable value
+
+      logical obl_not_found, ex_not_found,lsp_not_found !Loop variable (first call)
+
+      ! **********************************************************************
+      ! 0. Initializations
+      ! **********************************************************************
+
+          Year=year_bp_ini+year_PEM
+          timeperi_ls=timeperi*360/2/pi
+
+	  call ini_lask_param_mod(nlask)
+
+          print *, "orbit_param_criterion, Year in pem.def=", year_bp_ini
+          print *, "orbit_param_criterion, Year in the startpem.nc =", year_PEM
+          print *, "orbit_param_criterion, Current year=", Year
+          print *, "orbit_param_criterion, Current obl=", obliquit
+          print *, "orbit_param_criterion, Current ex=", e_elips
+          print *, "orbit_param_criterion, Current lsp=", timeperi_ls
+
+          open(73,file='ob_ex_lsp.asc')
+          do ilask=1,nlask
+            read(73,*) yearlask(ilask),oblask(ilask),      &
+             exlask(ilask),lsplask(ilask)
+            yearlask(ilask)=yearlask(ilask)*1000
+
+            if(yearlask(ilask).GT.Year) then
+		last_ilask=ilask+1
+            endif
+          end do
+          close(73)
+
+       print *, "Coresponding line in the ob_ex_lsp.asc file=", last_ilask
+
+! 5% max change case
+
+        max_change_obl=0.05
+        max_change_ex=0.05
+        max_change_lsp=0.05
+
+	max_obl=obliquit*(1+max_change_obl)
+	min_obl=obliquit*(1-max_change_obl)
+
+	max_ex=e_elips*(1+max_change_ex)
+	min_ex=e_elips*(1-max_change_ex)
+
+	max_lsp=timeperi_ls*(1+max_change_lsp)
+	min_lsp=timeperi_ls*(1-max_change_lsp)
+
+!End of 5% max change case
+
+!Constant max change case 
+
+        max_change_obl=0.01
+        max_change_ex=0.01
+        max_change_lsp=20.
+
+	max_obl=obliquit+max_change_obl
+	min_obl=obliquit-max_change_obl
+
+	max_ex=e_elips+max_change_ex
+	min_ex=e_elips-max_change_ex
+
+	max_lsp=timeperi_ls+max_change_lsp
+	min_lsp=timeperi_ls-max_change_lsp
+
+!End Constant max change case 
+
+        obl_not_found=.TRUE.
+        ex_not_found=.TRUE.
+        lsp_not_found=.TRUE.
+
+        max_obl_iter=999999999999
+        max_ex_iter =999999999999
+        max_lsp_iter=999999999999
+
+        do ilask=last_ilask+1,1,-1
+           if((oblask(ilask).GT.max_obl).and. obl_not_found ) then
+              max_obl_iter=(max_obl-oblask(ilask)) * (yearlask(ilask-1)-yearlask(ilask)) &
+                               / (oblask(ilask-1)-oblask(ilask))
+              obl_not_found=.FALSE.
+           elseif((oblask(ilask).LT.min_obl).and. obl_not_found ) then
+              max_obl_iter=(min_obl-oblask(ilask)) * (yearlask(ilask-1)-yearlask(ilask)) &
+                               / (oblask(ilask-1)-oblask(ilask))
+              obl_not_found=.FALSE.
+           endif
+           if((exlask(ilask).GT.max_ex).and. ex_not_found ) then
+              max_ex_iter=(max_ex-exlask(ilask)) * (yearlask(ilask-1)-yearlask(ilask)) &
+                               / (exlask(ilask-1)-exlask(ilask))
+              ex_not_found=.FALSE.
+           elseif((exlask(ilask).LT.min_ex ).and. ex_not_found ) then
+              max_ex_iter=(min_ex-exlask(ilask)) * (yearlask(ilask-1)-yearlask(ilask)) &
+                               / (exlask(ilask-1)-exlask(ilask))
+              ex_not_found=.FALSE.
+           endif
+           if((lsplask(ilask).GT.max_lsp).and. lsp_not_found ) then
+              max_lsp_iter=(max_lsp-lsplask(ilask)) * (yearlask(ilask-1)-yearlask(ilask)) &
+                               / (lsplask(ilask-1)-lsplask(ilask))
+              lsp_not_found=.FALSE.
+           elseif((lsplask(ilask).LT.min_lsp ).and. lsp_not_found ) then
+              max_lsp_iter=(min_lsp-lsplask(ilask)) * (yearlask(ilask-1)-yearlask(ilask)) &
+                               / (lsplask(ilask-1)-lsplask(ilask))
+              lsp_not_found=.FALSE.
+           endif
+        enddo
+
+      print *, "Maximum obliquity accepted=", max_obl
+      print *, "Minimum obliquity accepted=", min_obl
+      print *, "Maximum number of iteration for the obl. parameter=", max_obl_iter
+
+      print *, "Maximum excentricity accepted=", max_ex
+      print *, "Minimum excentricity accepted=", min_ex
+      print *, "Maximum number of iteration for the ex. parameter=", max_ex_iter
+
+      print *, "Maximum lsp accepted=", max_obl
+      print *, "Minimum lsp accepted=", min_obl
+      print *, "Maximum number of iteration for the lsp. parameter=", max_lsp_iter
+
+      year_iter_max=min(max_obl_iter,max_ex_iter,max_lsp_iter)
+
+      print *, "So the max. number of iteration (year) for the orbital parameter=", year_iter_max
+
+        END SUBROUTINE orbit_param_criterion
+
+!********************************************************************************   
+      
+      END MODULE orbit_param_criterion_mod
